## haskell-hadrian 9.10.3

=== hadrian/bindist/Makefile ===
MAKEFLAGS += --no-builtin-rules
.SUFFIXES:

# Configuration from the source distribution's configure script.
include ./mk/project.mk

# Configuration from the binary distribution's configure script.
include ./config.mk

.PHONY: default
default:
	@echo 'Run "make install" to install'
	@false

#-----------------------------------------------------------------------
# INSTALL RULES

# Hacky function to check equality of two strings
# TODO : find if a better function exists
eq=$(and $(findstring $(1),$(2)),$(findstring $(2),$(1)))

# patchpackageconf
#
# Hacky function to patch up the 'haddock-interfaces' and 'haddock-html'
# fields in the package .conf files
#
# $1 = package name (ex: 'bytestring')
# $2 = path to .conf file
# $3 = Docs Directory
# $4 = (relative) path from $${pkgroot} to docs directory ($3)
# $5 = package name and version (ex: bytestring-0.13)
#
define patchpackageconf \
	# We fix the paths to haddock files by using the relative path from the pkgroot
	# to the doc files.
	cat '$2' | sed 's|haddock-interfaces.*|haddock-interfaces: "$${pkgroot}/$4/html/libraries/$5/$1.haddock"|' \
	         | sed 's|haddock-html.*|haddock-html: "$${pkgroot}/$4/html/libraries/$5"|' \
		 | sed 's|    $${pkgroot}/../../doc/html/.*||' \
	       > '$2.copy'
	# The rts package doesn't actually supply haddocks, so we stop advertising them
	# altogether.
	((echo "$1" | grep rts) && (cat '$2.copy' | sed 's|haddock-.*||' > '$2.copy.copy')) || (cat '$2.copy' > '$2.copy.copy')
	# We finally replace the original file.
	mv '$2.copy.copy' '$2'
	# Fix the mode, in case umask is set
	chmod 644 '$2'
endef

# QUESTION : should we use shell commands?

.PHONY: show
show:
	@echo '$(VALUE)="$($(VALUE))"'


.PHONY: install_extra
ifeq "$(EnableDistroToolchain)" "NO"
ifeq "$(Windows_Host)" "YES"
install_extra: install_mingw
endif
endif
install_extra:

.PHONY: install_bin
ifeq "$(RelocatableBuild)" "YES"
install_bin: install_bin_direct
else
install_bin: install_bin_libdir install_wrappers
endif

.PHONY: install
install: install_bin install_lib install_extra
install: install_man install_docs update_package_db
install: install_data

ifeq "$(RelocatableBuild)" "YES"
ActualLibsDir=${ghclibdir}
ActualBinsDir=${bindir}
else
ActualLibsDir=${ghclibdir}/lib
ActualBinsDir=${ghclibdir}/bin
endif
WrapperBinsDir=${bindir}

# N.B. this is duplicated from includes/ghc.mk.
lib/settings : config.mk
	@rm -f $@
	@echo '[("C compiler command", "$(SettingsCCompilerCommand)")' >> $@
	@echo ',("C compiler flags", "$(SettingsCCompilerFlags)")' >> $@
	@echo ',("C++ compiler command", "$(SettingsCxxCompilerCommand)")' >> $@
	@echo ',("C++ compiler flags", "$(SettingsCxxCompilerFlags)")' >> $@
	@echo ',("C compiler link flags", "$(SettingsCCompilerLinkFlags)")' >> $@
	@echo ',("C compiler supports -no-pie", "$(SettingsCCompilerSupportsNoPie)")' >> $@
	@echo ',("CPP command", "$(SettingsCPPCommand)")' >> $@
	@echo ',("CPP flags", "$(SettingsCPPFlags)")' >> $@
	@echo ',("Haskell CPP command", "$(SettingsHaskellCPPCommand)")' >> $@
	@echo ',("Haskell CPP flags", "$(SettingsHaskellCPPFlags)")' >> $@
	@echo ',("JavaScript CPP command", "$(SettingsJavaScriptCPPCommand)")' >> $@
	@echo ',("JavaScript CPP flags", "$(SettingsJavaScriptCPPFlags)")' >> $@
	@echo ',("C-- CPP command", "$(SettingsCmmCPPCommand)")' >> $@
	@echo ',("C-- CPP flags", "$(SettingsCmmCPPFlags)")' >> $@
	@echo ',("C-- CPP supports -g0", "$(SettingsCmmCPPSupportsG0)")' >> $@
	@echo ',("ld supports compact unwind", "$(LdHasNoCompactUnwind)")' >> $@
	@echo ',("ld supports filelist", "$(LdHasFilelist)")' >> $@
	@echo ',("ld supports single module", "$(LdHasSingleModule)")' >> $@
	@echo ',("ld is GNU ld", "$(LdIsGNULd)")' >> $@
	@echo ',("Merge objects command", "$(SettingsMergeObjectsCommand)")' >> $@
	@echo ',("Merge objects flags", "$(SettingsMergeObjectsFlags)")' >> $@
	@echo ',("Merge objects supports response files", "$(MergeObjsSupportsResponseFiles)")' >> $@
	@echo ',("ar command", "$(SettingsArCommand)")' >> $@
	@echo ',("ar flags", "$(ArArgs)")' >> $@
	@echo ',("ar supports at file", "$(ArSupportsAtFile)")' >> $@
	@echo ',("ar supports -L", "$(ArSupportsDashL)")' >> $@
	@echo ',("ranlib command", "$(SettingsRanlibCommand)")' >> $@
	@echo ',("otool command", "$(SettingsOtoolCommand)")' >> $@
	@echo ',("install_name_tool command", "$(SettingsInstallNameToolCommand)")' >> $@
	@echo ',("windres command", "$(SettingsWindresCommand)")' >> $@
	@echo ',("unlit command", "$$topdir/../bin/$(CrossCompilePrefix)unlit")' >> $@
	@echo ',("cross compiling", "$(CrossCompiling)")' >> $@
	@echo ',("target platform string", "$(TARGETPLATFORM)")' >> $@
	@echo ',("target os", "$(HaskellTargetOs)")' >> $@
	@echo ',("target arch", "$(HaskellTargetArch)")' >> $@
	@echo ',("target word size", "$(TargetWordSize)")' >> $@
	@echo ',("target word big endian", "$(TargetWordBigEndian)")' >> $@
	@echo ',("target has GNU nonexec stack", "$(TargetHasGnuNonexecStack)")' >> $@
	@echo ',("target has .ident directive", "$(TargetHasIdentDirective)")' >> $@
	@echo ',("target has subsections via symbols", "$(TargetHasSubsectionsViaSymbols)")' >> $@
	@echo ',("target has libm", "$(TargetHasLibm)")' >> $@
	@echo ',("Unregisterised", "$(GhcUnregisterised)")' >> $@
	@echo ',("LLVM target", "$(LLVMTarget_CPP)")' >> $@
	@echo ',("LLVM llc command", "$(SettingsLlcCommand)")' >> $@
	@echo ',("LLVM opt command", "$(SettingsOptCommand)")' >> $@
	@echo ',("LLVM llvm-as command", "$(SettingsLlvmAsCommand)")' >> $@
	@echo ',("Use inplace MinGW toolchain", "$(SettingsUseDistroMINGW)")' >> $@
	@echo
	@echo ',("Use interpreter", "$(GhcWithInterpreter)")' >> $@
	@echo ',("Support SMP", "$(GhcWithSMP)")' >> $@
	@echo ',("RTS ways", "$(GhcRTSWays)")' >> $@
	@echo ',("Tables next to code", "$(TablesNextToCode)")' >> $@
	@echo ',("Leading underscore", "$(LeadingUnderscore)")' >> $@
	@echo ',("Use LibFFI", "$(UseLibffiForAdjustors)")' >> $@
	@echo ',("RTS expects libdw", "$(GhcRtsWithLibdw)")' >> $@
	@echo "]" >> $@

# We need to install binaries relative to libraries.
BINARIES = $(wildcard ./bin/*)
.PHONY: install_bin_libdir
install_bin_libdir:
	@echo "Copying binaries to $(DESTDIR)$(ActualBinsDir)"
	$(INSTALL_DIR) "$(DESTDIR)$(ActualBinsDir)"
	for i in $(BINARIES); do \
		if test -L "$$i"; then \
			cp -RP "$$i" "$(DESTDIR)$(ActualBinsDir)"; \
		else \
			$(INSTALL_PROGRAM) "$$i" "$(DESTDIR)$(ActualBinsDir)"; \
		fi; \
	done

.PHONY: install_bin_direct
install_bin_direct:
	@echo "Copying binaries to $(DESTDIR)$(WrapperBinsDir)"
	$(INSTALL_DIR) "$(DESTDIR)$(WrapperBinsDir)"
	$(INSTALL_PROGRAM) ./bin/* "$(DESTDIR)$(WrapperBinsDir)/"

.PHONY: install_lib
install_lib: lib/settings
	@echo "Copying libraries to $(DESTDIR)$(ActualLibsDir)"
	$(INSTALL_DIR) "$(DESTDIR)$(ActualLibsDir)"

	@dest="$(DESTDIR)$(ActualLibsDir)"; \
	cd ./lib; \
	for i in `$(FIND) . -type f`; do \
		dir="`dirname $$i`" ; \
		$(INSTALL_DIR) "$$dest/$$dir" ; \
		case $$i in \
		  *.a) \
		    $(INSTALL_DATA) $$i "$$dest/$$dir" ; \
		    $(RANLIB_CMD) "$$dest"/$$i ;; \
		  *.dll) \
		    $(INSTALL_PROGRAM) $$i "$$dest/$$dir" ; \
		    $(STRIP_CMD) "$$dest"/$$i ;; \
		  *.so) \
		    $(INSTALL_SHLIB) $$i "$$dest/$$dir" ;; \
		  *.dylib) \
		    $(INSTALL_SHLIB) $$i "$$dest/$$dir" ;; \
		  *.mjs) \
		    $(INSTALL_SCRIPT) $$i "$$dest/`dirname $$i`" ;; \
		  *) \
		    $(INSTALL_DATA) $$i "$$dest/`dirname $$i`" ;; \
		esac; \
	done; \

.PHONY: install_docs
install_docs:
	@echo "Copying docs to $(DESTDIR)$(docdir)"
	$(INSTALL_DIR) "$(DESTDIR)$(docdir)"

	if [ -d doc ]; then \
		cd ./doc; $(FIND) . -type f -exec sh -c \
			'$(INSTALL_DIR) "$(DESTDIR)$(docdir)/`dirname $$1`" && $(INSTALL_DATA) "$$1" "$(DESTDIR)$(docdir)/`dirname $$1`"' \
			sh '{}' ';'; \
	fi

	if [ -d docs-utils ]; then \
		$(INSTALL_DIR) "$(DESTDIR)$(docdir)/html/libraries/"; \
		$(INSTALL_DATA) docs-utils/prologue.txt "$(DESTDIR)$(docdir)/html/libraries/"; \
		$(INSTALL_SCRIPT) docs-utils/gen_contents_index "$(DESTDIR)$(docdir)/html/libraries/"; \
	fi

.PHONY: install_data
install_data:
	@echo "Copying data to $(DESTDIR)share"
	$(INSTALL_DIR) "$(DESTDIR)$(datadir)"
	if [ -d share ]; then \
		cd ./share; $(FIND) . -type f -exec sh -c \
			'$(INSTALL_DIR) "$(DESTDIR)$(datadir)/`dirname $$1`" && \
			$(INSTALL_DATA) "$$1" "$(DESTDIR)$(datadir)/`dirname $$1`"' \
			sh '{}' ';'; \
	fi

MAN_SECTION := 1
MAN_PAGES := manpage/ghc.1

.PHONY: install_man
install_man:
	if [ -f $(MAN_PAGES) ]; then \
		$(INSTALL_DIR) "$(DESTDIR)$(mandir)"; \
		$(INSTALL_DIR) "$(DESTDIR)$(mandir)/man$(MAN_SECTION)"; \
		$(INSTALL_MAN) $(INSTALL_OPTS) $(MAN_PAGES) "$(DESTDIR)$(mandir)/man$(MAN_SECTION)"; \
	fi

export SHELL
.PHONY: install_wrappers
install_wrappers: install_bin_libdir install_hsc2hs_wrapper
	@echo "Installing wrapper scripts"
	$(INSTALL_DIR) "$(DESTDIR)$(WrapperBinsDir)"
	for p in `cd ./wrappers; $(FIND) . ! -type d`; do \
	    mk/install_script.sh "$$p" "$(DESTDIR)/$(WrapperBinsDir)/$$p" "$(WrapperBinsDir)" "$(ActualBinsDir)" "$(ActualBinsDir)/$$p" "$(ActualLibsDir)" "$(docdir)" "$(includedir)"; \
	done

.PHONY: install_hsc2hs_wrapper
install_hsc2hs_wrapper:
	@echo Copying hsc2hs wrapper
	cp mk/hsc2hs wrappers/hsc2hs-ghc-$(ProjectVersion)

PKG_CONFS = $(shell find "$(DESTDIR)$(ActualLibsDir)/package.conf.d" -name '*.conf' | sed "s:   :\0xxx\0:g")
.PHONY: update_package_db
update_package_db: install_bin install_lib
	@echo "Installing C++ standard library virtual package"
	$(INSTALL_DATA) mk/system-cxx-std-lib-1.0.conf "$(DESTDIR)$(ActualLibsDir)/package.conf.d"
	@echo "Updating the package DB"
	$(foreach p, $(PKG_CONFS),\
		$(call patchpackageconf,$(shell echo $(notdir $p) | sed 's/-[0-9.]*-[0-9a-zA-Z]*\.conf//g'),$(shell echo "$p" | sed 's:\0xxx\0:   :g'),$(docdir),$(shell mk/relpath.sh "$(ActualLibsDir)" "$(docdir)"),$(shell echo $(notdir $p) | sed 's/.conf//g')))
	'$(DESTDIR)$(ActualBinsDir)/$(CrossCompilePrefix)ghc-pkg' --global-package-db "$(DESTDIR)$(ActualLibsDir)/package.conf.d" recache

.PHONY: install_mingw
install_mingw:
	@echo "Installing MingGW"
	$(INSTALL_DIR) "$(DESTDIR)$(prefix)/mingw"
	cp -Rp ./mingw "$(DESTDIR)$(prefix)"

# END INSTALL
# ----------------------------------------------------------------------

## haskell-hadrian 9.4.7

=== debian/changelog ===
haskell-hadrian (9.4.7-3build2) noble; urgency=medium

  * Rebuild against new GHC ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 11 Nov 2023 08:37:23 +0100

haskell-hadrian (9.4.7-3build1) noble; urgency=medium

  * Rebuild against new GHC ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 29 Oct 2023 10:27:57 +0100

haskell-hadrian (9.4.7-3) unstable; urgency=medium

  * Enable GHCi on all platforms

 -- Ilias Tsitsimpis <iliastsi@debian.org>  Sat, 14 Oct 2023 14:18:18 +0300

haskell-hadrian (9.4.7-2) unstable; urgency=medium

  * Relax versioned dependency on GHC
  * Pass -DNOSMP to C compiler when needed

 -- Ilias Tsitsimpis <iliastsi@debian.org>  Thu, 12 Oct 2023 18:13:26 +0300

haskell-hadrian (9.4.7-1) unstable; urgency=low

  * Initial release

 -- Ilias Tsitsimpis <iliastsi@debian.org>  Sat, 30 Sep 2023 18:13:35 +0300

=== debian/control ===
Source: haskell-hadrian
Maintainer: Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>
Uploaders:
 Ilias Tsitsimpis <iliastsi@debian.org>,
Priority: optional
Section: haskell
Rules-Requires-Root: no
Build-Depends: debhelper (>= 10),
 haskell-devscripts (>= 0.13),
 cdbs,
 ghc (>= 9.0),
 libghc-extra-dev (>= 1.4.7),
 libghc-shake-dev (>= 0.18.3),
 libghc-shake-dev (<< 0.20),
 libghc-unordered-containers-dev (>= 0.2.1),
 libghc-unordered-containers-dev (<< 0.3),
Standards-Version: 4.6.2
Homepage: https://www.haskell.org/ghc/
Vcs-Browser: https://salsa.debian.org/haskell-team/DHG_packages/tree/master/p/haskell-hadrian
Vcs-Git: https://salsa.debian.org/haskell-team/DHG_packages.git [p/haskell-hadrian]
X-Description: build system for GHC
 Hadrian is a modular, statically-typed, extensible build system for GHC,
 introduced in the paper Non-recursive Make Considered Harmful. It consists of
 a Haskell executable implemented using the shake library, and is used to
 configure and build GHC.

Package: hadrian
Architecture: any
Depends: ${haskell:Depends},
 ${misc:Depends},
 ${shlibs:Depends},
Recommends: ${haskell:Recommends},
Suggests: ${haskell:Suggests},
Conflicts: ${haskell:Conflicts},
Provides: ${haskell:Provides},
Description: ${haskell:ShortDescription}${haskell:ShortBlurb}
 ${haskell:LongDescription}
 .
 ${haskell:Blurb}

=== debian/rules ===
#!/usr/bin/make -f

# Tests require having the full GHC source code
DEB_ENABLE_TESTS = no
DEB_SETUP_GHC_CONFIGURE_ARGS += -f-selftest -f-threaded

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/hlibrary.mk

build/hadrian:: build-ghc-stamp

## haskell-hadrian 9.6.6

=== debian/changelog ===
haskell-hadrian (9.6.6-2) unstable; urgency=medium

  * Relax dependency on Cabal (Closes: #1084264)

 -- Ilias Tsitsimpis <iliastsi@debian.org>  Mon, 07 Oct 2024 20:05:07 +0300

haskell-hadrian (9.6.6-1) unstable; urgency=medium

  * Upload to unstable
  * Declare compliance with Debian policy 4.7.0

 -- Ilias Tsitsimpis <iliastsi@debian.org>  Wed, 11 Sep 2024 15:17:30 +0300

haskell-hadrian (9.6.6-1~exp1) experimental; urgency=medium

  * New upstream release.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 17 Jul 2024 10:34:46 +0200

haskell-hadrian (9.6.5-1~exp1) experimental; urgency=medium

  * New upstream release

 -- Ilias Tsitsimpis <iliastsi@debian.org>  Thu, 02 May 2024 10:20:21 +0300

haskell-hadrian (9.6.4-1~exp1) experimental; urgency=medium

  * New upstream release

 -- Ilias Tsitsimpis <iliastsi@debian.org>  Sat, 13 Jan 2024 16:15:06 +0200

haskell-hadrian (9.6.3-1~exp1) experimental; urgency=medium

  * New upstream release

 -- Ilias Tsitsimpis <iliastsi@debian.org>  Mon, 18 Dec 2023 17:16:29 +0200

haskell-hadrian (9.4.8-1~exp1) experimental; urgency=medium

  * New upstream release
  * Support hurd-i386 (Closes: #1056306)

 -- Ilias Tsitsimpis <iliastsi@debian.org>  Sat, 16 Dec 2023 16:48:48 +0200

=== debian/control ===
--- 
+++ 
@@ -14,7 +14,7 @@
  libghc-shake-dev (<< 0.20),
  libghc-unordered-containers-dev (>= 0.2.1),
  libghc-unordered-containers-dev (<< 0.3),
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Homepage: https://www.haskell.org/ghc/
 Vcs-Browser: https://salsa.debian.org/haskell-team/DHG_packages/tree/master/p/haskell-hadrian
 Vcs-Git: https://salsa.debian.org/haskell-team/DHG_packages.git [p/haskell-hadrian]

## haskell-hadrian 9.8.4

=== debian/changelog ===
haskell-hadrian (9.8.4-0~0exp1) experimental; urgency=medium

  * New upstream version.

 -- Clint Adams <clint@debian.org>  Thu, 11 Sep 2025 07:51:48 -0400

=== debian/control ===
--- 
+++ 
@@ -14,7 +14,11 @@
  libghc-shake-dev (<< 0.20),
  libghc-unordered-containers-dev (>= 0.2.1),
  libghc-unordered-containers-dev (<< 0.3),
-Standards-Version: 4.7.0
+ libghc-base16-bytestring-dev (>= 0.1.1),
+ libghc-base16-bytestring-dev (<< 1.1.0.0),
+ libghc-cryptohash-sha256-dev (>= 0.11),
+ libghc-cryptohash-sha256-dev (<< 0.12),
+Standards-Version: 4.7.2
 Homepage: https://www.haskell.org/ghc/
 Vcs-Browser: https://salsa.debian.org/haskell-team/DHG_packages/tree/master/p/haskell-hadrian
 Vcs-Git: https://salsa.debian.org/haskell-team/DHG_packages.git [p/haskell-hadrian]

## haskell-hadrian 9.10.3

=== debian/changelog ===
haskell-hadrian (9.10.3-1~exp2) experimental; urgency=medium

  * Do not use cabal-install

 -- Ilias Tsitsimpis <iliastsi@debian.org>  Sat, 27 Sep 2025 23:59:04 +0300

haskell-hadrian (9.10.3-1~exp1) experimental; urgency=medium

  * New upstream version.

 -- Ilias Tsitsimpis <iliastsi@debian.org>  Sat, 27 Sep 2025 15:19:01 +0300

=== debian/control ===
Source: haskell-hadrian
Maintainer: Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>
Uploaders:
 Ilias Tsitsimpis <iliastsi@debian.org>,
Priority: optional
Section: haskell
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 ghc (>= 9.6),
 libghc-extra-dev (>= 1.4.7),
 libghc-shake-dev (>= 0.18.3),
 libghc-shake-dev (<< 0.20),
 libghc-unordered-containers-dev (>= 0.2.1),
 libghc-unordered-containers-dev (<< 0.3),
 libghc-base16-bytestring-dev (>= 0.1.1),
 libghc-base16-bytestring-dev (<< 1.1.0.0),
 libghc-cryptohash-sha256-dev (>= 0.11),
 libghc-cryptohash-sha256-dev (<< 0.12),
Standards-Version: 4.7.2
Homepage: https://www.haskell.org/ghc/
Vcs-Browser: https://salsa.debian.org/haskell-team/DHG_packages/tree/master/p/haskell-hadrian
Vcs-Git: https://salsa.debian.org/haskell-team/DHG_packages.git [p/haskell-hadrian]

Package: hadrian
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: build system for GHC
 Hadrian is a modular, statically-typed, extensible build system for GHC,
 introduced in the paper Non-recursive Make Considered Harmful. It consists of
 a Haskell executable implemented using the shake library, and is used to
 configure and build GHC.

=== debian/rules ===
#!/usr/bin/make -f

SETUP := $(CURDIR)/setup
PKG_DB := $(CURDIR)/debian/packages.conf/
INSTDIR := $(CURDIR)/tmp/

define build
	$(SETUP) configure --package-db=$(PKG_DB) --prefix=$(INSTDIR) -O ${1} \
		&& $(SETUP) build --builddir=dist \
		&& $(SETUP) install --builddir=dist
endef


%:
	dh $@

.PHONY: override_dh_auto_build
override_dh_auto_build:
	ghc -O -o $(SETUP) hadrian/Setup.hs
	ghc-pkg init $(PKG_DB)
	cd libraries/ghc-platform/ && $(call build)
	cd utils/ghc-toolchain/ && $(call build)
	cd hadrian && $(call build, -f-selftest -f-threaded)

.PHONY: override_dh_auto_clean
override_dh_auto_clean:
	dh_auto_clean
	rm -f $(SETUP) hadrian/Setup.o hadrian/Setup.hi
	rm -rf libraries/ghc-platform/dist
	rm -rf utils/ghc-toolchain/dist
	rm -rf hadrian/dist
	rm -rf $(PKG_DB) $(INSTDIR)

.PHONY: override_dh_strip
override_dh_strip:
	dh_strip --no-automatic-dbgsym

=== debian/watch ===
version=4
opts="pgpmode=none,dirversionmangle=s/-rc/~rc/" \
https://downloads.haskell.org/~ghc/(\d[\d.rc-]*)/ghc-(\d[\d.]*)-src.tar.(?:bz2|xz|gz) \
debian debian/uscan-repack.sh
